// mstst32.h : main header file for the MSTST32 application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

class CMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CMstst32App:
// See mstst32.cpp for the implementation of this class
//

class CMstst32App : public CWinApp
{
public:
	CMainFrame * m_pMainFrame;
	BOOLEAN m_bWindowsNT;
	CMstst32App();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMstst32App)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CMstst32App)
	afx_msg void OnAppAbout();
	afx_msg void OnCameraEstablish2ndlink();
	afx_msg void OnCameraSelectFilter();
	//}}AFX_MSG
	afx_msg void OnCameraOpenDriver();
	afx_msg void OnCameraCloseDriver();
	afx_msg void OnCameraGetDriverInfo();
	afx_msg void OnCameraEstablishLink();
	afx_msg void OnCameraGetCCDInfo();
	afx_msg void OnCameraTakeTrackingImage();
	afx_msg void OnCameraTakeImagingImage();
	afx_msg void OnCameraUpdateClock();
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
