VERSION 5.00
Begin VB.Form frmST5Cdriver 
   Caption         =   "ST-5C Camera Driver Test Program"
   ClientHeight    =   4875
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6000
   LinkTopic       =   "Form1"
   ScaleHeight     =   325
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   400
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tditimer 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   11400
      Top             =   4200
   End
   Begin VB.Timer Tmrreadtemp 
      Interval        =   1000
      Left            =   11400
      Top             =   4680
   End
   Begin VB.CommandButton cmdexit 
      Caption         =   "&Exit"
      Height          =   495
      Left            =   5400
      TabIndex        =   0
      Top             =   4320
      Width           =   495
   End
   Begin VB.Label lblprogress 
      Height          =   375
      Left            =   4680
      TabIndex        =   6
      Top             =   3840
      Width           =   1095
   End
   Begin VB.Label lblprogresslabel 
      Caption         =   "Line being readout"
      Height          =   495
      Left            =   3720
      TabIndex        =   5
      Top             =   3840
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Temp:"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   4320
      Width           =   615
   End
   Begin VB.Label lbltemp 
      Height          =   375
      Left            =   840
      TabIndex        =   3
      Top             =   4320
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Result:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   3840
      Width           =   735
   End
   Begin VB.Label lblresult 
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   3840
      Width           =   2655
   End
   Begin VB.Menu mnucamera 
      Caption         =   "Camera"
      Begin VB.Menu mnuopendriver 
         Caption         =   "Open Driver"
      End
      Begin VB.Menu mnugetinfo 
         Caption         =   "Get Info"
      End
      Begin VB.Menu mnuestablishlink 
         Caption         =   "Establish Link"
      End
      Begin VB.Menu mnusettemp 
         Caption         =   "Set Temperature"
      End
      Begin VB.Menu mnushowtemp 
         Caption         =   "Show Temperature"
      End
      Begin VB.Menu mnuclosedriver 
         Caption         =   "Close Driver"
      End
      Begin VB.Menu mnuexit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnugrab 
      Caption         =   "Grab"
      Begin VB.Menu mnusetupexposure 
         Caption         =   "Setup Exposure"
      End
      Begin VB.Menu mnulightexposure 
         Caption         =   "Take light exposure"
      End
      Begin VB.Menu mnudarkexposure 
         Caption         =   "Take dark exposure"
      End
   End
   Begin VB.Menu mnudisplay 
      Caption         =   "Display"
      Begin VB.Menu mnucontrast 
         Caption         =   "Adjust Contrast"
      End
      Begin VB.Menu mnushowcross 
         Caption         =   "Show Crosshairs"
      End
      Begin VB.Menu mnuhidecross 
         Caption         =   "Hide Crosshainrs"
      End
   End
   Begin VB.Menu mnufileio 
      Caption         =   "File I/O"
      Begin VB.Menu mnuload 
         Caption         =   "Load ST-5C Frame"
      End
      Begin VB.Menu mnusave 
         Caption         =   "Save ST-5C Frame"
      End
   End
End
Attribute VB_Name = "frmST5Cdriver"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim gdip As GetDriverInfoParams
Dim gdir As GetDriverInfoResults0
Dim elp As EstablishLinkParams
Dim elr As EstablishLinkResults
Dim sep As StartExposureParams
Dim rlp As ReadoutLineParams
Dim eep As EndExposureParams
Dim qcsp As QueryCommandStatusParams
Dim qcsr As QueryCommandStatusResults
Dim strp As SetTemperatureRegulationParams
Dim qtsr As QueryTemperatureStatusResults
Dim pop As PulseOutParams
Dim odp As OpenDeviceParams
Dim exposuretime, defaultexposure As Single
Dim exposure, min, max As Long
Dim imagedata(0 To 319, 0 To 239) As Integer
Dim linedata(0 To 319) As Integer
Dim background, range, imageheight, imagewidth, lastdrivelevel As Integer
Dim showcrosshairdata, establishlink, darkframe As Boolean

Private Sub cmdexit_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End
End Sub

Private Sub Form_Load()
exposure = 100
showcrosshairdata = False
defaultexposure = 1
lastdrivelevel = 0
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim i, j As Integer
If showcrosshairdata = True Then
    i = CInt(x - 40)
    j = CInt(y - 10)
    If i > -1 Then
        If j > -1 Then
            If i < 320 Then
                If j < 240 Then
                    lblresult.Caption = "Pixel position (" & Str(i) & ", " & Str(j) & ") = " & Str(imagedata(i, j))
                End If
            End If
        End If
    End If
End If
End Sub

Private Sub mnuclosedriver_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End Sub

Private Sub mnucontrast_Click()
background = InputBox("Input new background: ", "Set New Background", Str(background))
range = InputBox("Input new range: ", "Set New Range", Str(range))
redrawimage
End Sub

Private Sub mnudarkexposure_Click()
darkframe = True
mnutakeexposure
End Sub

Private Sub mnuestablishlink_Click()
Dim i As Integer
elp.port = 0
elp.baseAddress = &H378 'lpt1 on my machine - set for your configuration
i = ParDrvCommandVB(CC_ESTABLISH_LINK, elp, elr)
lblresult.Caption = "Error Code = " & Str(i) & ", camera type = " & Hex(elr.cameraType)
If i = 0 Then
establishlink = True
End If
End Sub

Private Sub mnuexit_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End
End Sub


Private Sub mnugetinfo_Click()
Dim i As Integer
i = ParDrvCommandVB(CC_GET_DRIVER_INFO, gdip, gdir)
lblresult.Caption = "Version = " & Hex(gdir.version) & "; Name: " & gdir.name
End Sub

Private Sub mnuhidecross_Click()
frmST5Cdriver.MousePointer = 0
showcrosshairdata = False
End Sub

Private Sub mnulightexposure_Click()
darkframe = False
mnutakeexposure
End Sub

Private Sub mnuopendriver_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_OPEN_DRIVER, 0, 0)
If i1 = 0 Then
    odp.port = 1 'lpt1
    i2 = ParDrvCommandVB(CC_OPEN_DEVICE, odp, 0)
End If
lblresult.Caption = Str(i1) & "," & Str(i2)
End Sub

Private Sub mnusave_Click()
Dim textline, endstring, wrap, header, controlz, desc As String
Dim alltext As String
Dim i, j, lineLength, filenum, pixeldata As Integer
Dim x, y, oldx, oldy As Single
Dim sum, numbytes As Long
Dim currenttime As Variant
wrap = Chr$(10) & Chr$(13)
controlz = Chr$(26)
alltext = "PixCel255 Image" & wrap
alltext = alltext & "File_version = 3" & wrap
alltext = alltext & "Data_version = 1" & wrap
alltext = alltext & "Exposure = 100" & wrap
alltext = alltext & "Focal_length = 50.000" & wrap
alltext = alltext & "Aperture = 40.000" & wrap
alltext = alltext & "Response_factor = 2000.000" & wrap
alltext = alltext & "Note = -" & wrap
alltext = alltext & "Background = " & Str(background) & wrap
alltext = alltext & "Range = " & Str(range) & wrap
alltext = alltext & "Height = " & Str(imageheight) & wrap
alltext = alltext & "Width = " & Str(imagewidth) & wrap
alltext = alltext & "Date = " & Str(Date) & wrap
alltext = alltext & "Time = " & Format(Time, "h:mm:ss") & wrap
alltext = alltext & "Exposure_state = 356" & wrap
alltext = alltext & "Temperature = 0.00" & wrap
alltext = alltext & "Number_exposures = 1" & wrap
alltext = alltext & "Each_exposure = 100" & wrap
alltext = alltext & "History = 0" & wrap
alltext = alltext & "Observer = -" & wrap
alltext = alltext & "X_pixel_size = 0.010" & wrap
alltext = alltext & "Y_pixel_size = 0.010" & wrap
alltext = alltext & "Pedestal = 0" & wrap
alltext = alltext & "E_gain = 1.25" & wrap
alltext = alltext & "End" & wrap
alltext = alltext & controlz
numbytes = Len(alltext)
i = 2048 - numbytes
For j = 1 To i
    alltext = alltext & " "
Next 'j
desc = InputBox("Input file name (without extension): ", "File name", "test")
filenum = FreeFile
lblresult.Caption = ""
Open "c:\vbprog\SBIG\" & desc & ".255" For Binary As filenum
For i = 1 To 2048
    Put #filenum, , CByte(Asc(Mid(alltext, i, 1)))
Next i
Put #filenum, , imagedata
Close filenum
lblresult.Caption = "Save completed"
End Sub

Private Sub mnusettemp_Click()
Dim tedrive As Byte
Dim i As Integer
strp.regulation = 2
tedrive = CByte(InputBox("Input Cooler Drive Level (0 to 255) ", "TE Cooler Drive Level", lastdrivelevel))
lastdrivelevel = tedrive
strp.ccdSetpoint = tedrive
i = ParDrvCommandVB(CC_SET_TEMPERATURE_REGULATION, strp, 0)
If i <> 0 Then
    MsgBox "Set drive level command failed!"
    Exit Sub
End If
End Sub

Private Sub mnusetupexposure_click()
exposuretime = InputBox("Input exposure time: ", "Exposure Time", defaultexposure)
defaultexposure = exposuretime
exposure = CLng(exposuretime * 100)
 'following code is done to fix problem dll modules have with longs
sep.expLowByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expMidLowByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expMidHighByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expHighByte = CByte(exposure)
End Sub

Private Sub mnushowcross_Click()
frmST5Cdriver.MousePointer = 2
showcrosshairdata = True
End Sub

Private Sub mnushowtemp_Click()
Dim i As Integer
i = ParDrvCommandVB(CC_QUERY_TEMPERATURE_STATUS, 0, qtsr)
lbltemp.Caption = "Ambient Temp in A/D units = " & Str(qtsr.ambientThermistor) & ", CCD temperature = " & Str(qtsr.ccdThermistor)
End Sub

Private Sub mnutakeexposure()
Dim i, j, k, target As Integer
Dim exp, pixelvalue As Long
Dim wrap As String
wrap = Chr$(10) & Chr$(13)
pop.numberPulses = 1
pop.pulseWidth = 0
If darkframe = False Then
    pop.pulsePeriod = 1 ' opens filter wheel to clear position
Else
    pop.pulsePeriod = 2 ' closes filter wheel to opaque position
End If
sep.ccd = 0
sep.abgState = 0
sep.openShutter = 0
Tmrreadtemp.enabled = False
lblresult.Caption = "Starting Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Open shutter command failed!"
    Exit Sub
End If
qcsp.command = 8
If darkframe = True Then
    target = 4
Else
    target = 2
End If
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> target   'wait for shutter to rotate to clear position
lblresult.Caption = "shutter at position"
lblresult.Refresh
i = ParDrvCommandVB(CC_START_EXPOSURE, sep, 0)
If i <> 0 Then
    MsgBox "Start exposure command failed!"
    Exit Sub
End If
qcsp.command = 1
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 3   'waiting for imaging CCD to finish
eep.ccd = 0
lblresult.Caption = "Ending Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_END_EXPOSURE, eep, 0)
If i <> 0 Then
    MsgBox "End exposure command failed!"
    Exit Sub
End If
rlp.ccd = 0
rlp.readoutMode = 0 'full resolution
rlp.pixelStart = 0
rlp.pixelLength = 320
lblresult.Caption = "Reading Out CCD"
lblresult.Refresh
lblprogresslabel.Caption = "Line being readout"
lblprogresslabel.Refresh
For j = 0 To 239
    If j Mod 20 = 0 Then
        lblprogress.Caption = Str(j)
        lblprogress.Refresh
    End If
    i = ParDrvCommandVB(CC_READOUT_LINE, rlp, linedata(0))
    If i <> 0 Then
        MsgBox "Readout exposure command failed for line " & Str(j)
        Exit Sub
    End If
' Visual Basic does not have word data types, so I truncate
' the data to avoid negative values
    For k = 0 To 319
    If linedata(k) > 0 Then
        imagedata(k, j) = linedata(k)
    Else
        imagedata(k, j) = 32767
    End If
    Next 'k
Next 'j
lblprogress.Caption = Str(j - 1)
lblprogress.Refresh
imageheight = 240
imagewidth = 320
min = 32767
max = 0
For j = 0 To imageheight - 1
    If imagedata(imagewidth \ 2, j) < min Then
    min = imagedata(imagewidth \ 2, j)
    End If
    If imagedata(imagewidth \ 2, j) > max Then
    max = imagedata(imagewidth \ 2, j)
    End If
Next j
background = min
range = max - min
lblresult.Caption = "Minimum value = " & Str(min) & wrap & "Maximum value = " & Str(max)
lblresult.Refresh
Tmrreadtemp.enabled = True
redrawimage
End Sub

Private Sub redrawimage()
Dim i, j, pixdata As Integer
Dim pixvalue As Byte
Dim rangedivider, pix As Single
rangedivider = range / 255#
If rangedivider < 1 Then
    rangedivider = 1
End If
lblprogresslabel.Caption = "Line being displayed"
lblprogresslabel.Refresh
For j = 0 To imageheight - 1
    If j Mod 20 = 0 Then
        lblprogress.Caption = Str(j)
        lblprogress.Refresh
    End If
    For i = 0 To imagewidth - 1
        pix = (imagedata(i, j) - background) / rangedivider
        pixdata = CLng(pix)
        If pixdata > 255 Then
            pixdata = 255
        End If
        If pixdata < 0 Then
            pixdata = 0
        End If
        pixvalue = CByte(pixdata)
        frmST5Cdriver.PSet (i + 40, j + 10), RGB(pixvalue, pixvalue, pixvalue)
    Next 'i
Next 'j
lblprogress.Caption = Str(j - 1)
lblprogress.Refresh
End Sub


Private Sub Tmrreadtemp_Timer()
Dim i As Integer
Dim wrap As String
wrap = Chr$(10) & Chr$(13)
If establishlink = True Then
i = ParDrvCommandVB(CC_QUERY_TEMPERATURE_STATUS, 0, qtsr)
lbltemp.Caption = "Ambient Temp in A/D units = " & Str(qtsr.ambientThermistor) & wrap & "CCD temp in A/D units = " & Str(qtsr.ccdThermistor)
End If
End Sub


Private Sub mnuload_Click()
Dim alltext, textline, endstring, wrap, desc, header As String
Dim lineLength, filenum As Integer
Dim i, j As Integer
desc = InputBox("Input file name (without extension): ", "File name", "test")
wrap = Chr$(13) & Chr$(10)
filenum = FreeFile
Open "c:\vbprog\SBIG\" & desc & ".255" For Input As filenum
Do
Line Input #filenum, textline
lineLength = Len(textline)
lineLength = lineLength - 1
If lineLength >= 3 Then
    alltext = alltext & Mid$(textline, 1, lineLength) & wrap
    endstring = Mid$(textline, 1, 3)
    If Mid$(textline, 1, 8) = "Height =" Then
        imageheight = CInt(Mid$(textline, 10, lineLength - 9))
    End If 'height
    If Mid$(textline, 1, 7) = "Width =" Then
        imagewidth = CInt(Mid$(textline, 9, lineLength - 8))
    End If 'width
    If Mid$(textline, 1, 12) = "Background =" Then
        background = CInt(Mid$(textline, 14, lineLength - 13))
    End If 'background
    If Mid$(textline, 1, 7) = "Range =" Then
        range = CInt(Mid$(textline, 9, lineLength - 8))
    End If 'range
End If
Loop While endstring <> "End"
Close filenum
header = " "
filenum = FreeFile
lblresult.Caption = ""
Open "c:\vbprog\SBIG\" & desc & ".255" For Binary As filenum
Get #filenum, 2048, header
Get #filenum, , imagedata
Close filenum
lblresult.Caption = "Width = " & Str(imagewidth) & "  Height = " & Str(imageheight)
redrawimage
End Sub

