/*

	Camera.c - Conatis the camera bottleneck code.

*/
#include "stdafx.h"
#include "mstst32.h"

#include "pardrv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern CMstst32App theApp;

/*

	Include both prototypes here since this code
	can run under NT or 9X.

*/
extern "C" __declspec(dllexport) short ParDeviceCommandNH(short cmd, void *Params, void *Results);
extern "C" __declspec(dllexport) short ParDrvCommand(short cmd, void *Params, void *Results);

PAR_ERROR CameraCommand(short cmd, void *Params, void *Results)
{
	PAR_ERROR res;

	if ( theApp.m_bWindowsNT )
		res = (PAR_ERROR)ParDeviceCommandNH(cmd, Params, Results);
	else
		res = (PAR_ERROR)ParDrvCommand(cmd, Params, Results);
	return res;
}