VERSION 5.00
Begin VB.Form frmST7driver 
   Caption         =   "ST-7 Camera Software Example Program"
   ClientHeight    =   8985
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   12735
   LinkTopic       =   "Form1"
   ScaleHeight     =   599
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   849
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Tmrreadtemp 
      Interval        =   1000
      Left            =   12120
      Top             =   7800
   End
   Begin VB.CommandButton cmdexit 
      Caption         =   "&Exit"
      Height          =   495
      Left            =   12120
      TabIndex        =   0
      Top             =   8400
      Width           =   495
   End
   Begin VB.Label lblprogress 
      Height          =   375
      Left            =   9120
      TabIndex        =   6
      Top             =   8400
      Width           =   975
   End
   Begin VB.Label lblprogresslabel 
      Caption         =   "Line being readout"
      Height          =   375
      Left            =   8040
      TabIndex        =   5
      Top             =   8400
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Temp:"
      Height          =   375
      Left            =   4320
      TabIndex        =   4
      Top             =   8400
      Width           =   615
   End
   Begin VB.Label lbltemp 
      Height          =   375
      Left            =   5160
      TabIndex        =   3
      Top             =   8400
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Result:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   8400
      Width           =   735
   End
   Begin VB.Label lblresult 
      Height          =   375
      Left            =   960
      TabIndex        =   1
      Top             =   8400
      Width           =   3135
   End
   Begin VB.Menu mnucamera 
      Caption         =   "Camera"
      Begin VB.Menu mnuopendriver 
         Caption         =   "Open Driver"
      End
      Begin VB.Menu mnugetinfo 
         Caption         =   "Get Info"
      End
      Begin VB.Menu mnuestablishlink 
         Caption         =   "Establish Link"
      End
      Begin VB.Menu mnusettemp 
         Caption         =   "Set Temperature"
      End
      Begin VB.Menu mnushowtemp 
         Caption         =   "Show Temperature"
      End
      Begin VB.Menu mnuclosedriver 
         Caption         =   "Close Driver"
      End
      Begin VB.Menu mnuexit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnugrab 
      Caption         =   "Grab"
      Begin VB.Menu mnusetupexposure 
         Caption         =   "Setup Exposure"
      End
      Begin VB.Menu mnutakest7exposure 
         Caption         =   "Take ST-7 exposure"
      End
      Begin VB.Menu mnutakest8exposure 
         Caption         =   "Take Binned ST-8 Exposure"
      End
      Begin VB.Menu mnutrackccdexposure 
         Caption         =   "Take Tracking CCD Exposure"
      End
   End
   Begin VB.Menu mnudisplay 
      Caption         =   "Display"
      Begin VB.Menu mnucontrast 
         Caption         =   "Adjust Contrast"
      End
      Begin VB.Menu mnushowcross 
         Caption         =   "Show Crosshairs"
      End
      Begin VB.Menu mnuhidecross 
         Caption         =   "Hide Crosshairs"
      End
   End
   Begin VB.Menu mnufileio 
      Caption         =   "File I/O"
      Begin VB.Menu mnuload 
         Caption         =   "Load Image"
      End
      Begin VB.Menu mnusave 
         Caption         =   "Save Image"
      End
   End
   Begin VB.Menu mnuAO 
      Caption         =   "AO "
      Begin VB.Menu mnucenterao 
         Caption         =   "Center AO"
      End
      Begin VB.Menu mnumoveao 
         Caption         =   "Move AO"
      End
   End
   Begin VB.Menu mnufilter 
      Caption         =   "Filter"
      Begin VB.Menu mnured 
         Caption         =   "Red"
      End
      Begin VB.Menu mnugreen 
         Caption         =   "Green"
      End
      Begin VB.Menu mnublue 
         Caption         =   "Blue"
      End
      Begin VB.Menu mnuclear 
         Caption         =   "Clear"
      End
      Begin VB.Menu mnuuser 
         Caption         =   "User"
      End
   End
End
Attribute VB_Name = "frmST7driver"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim gdip As GetDriverInfoParams
Dim gdir As GetDriverInfoResults0
Dim elp As EstablishLinkParams
Dim elr As EstablishLinkResults
Dim sep As StartExposureParams
Dim rlp As ReadoutLineParams
Dim eep As EndExposureParams
Dim qcsp As QueryCommandStatusParams
Dim qcsr As QueryCommandStatusResults
Dim strp As SetTemperatureRegulationParams
Dim qtsr As QueryTemperatureStatusResults
Dim pop As PulseOutParams
Dim aottp As AOTipTiltParams
Dim exposuretime, defaultexposure As Single
Dim exposure, min, max As Long
Dim imagedata(0 To 764, 0 To 509) As Integer
Dim linedata(0 To 764) As Integer
Dim background, range, imageheight, imagewidth, lastdrivelevel As Integer
Dim showcrosshairdata, establishlink, darkframe, ST8camera As Boolean

Private Sub cmdexit_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End
End Sub

Private Sub Form_Load()
exposure = 100
showcrosshairdata = False
defaultexposure = 1
lastdrivelevel = 0
range = 1024
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim i, j As Integer
If showcrosshairdata = True Then
    i = CInt(x - 40)
    j = CInt(y - 10)
    If i > -1 Then
        If j > -1 Then
            If i < imagewidth Then
                If j < imageheight Then
                    lblresult.Caption = "Pixel position (" & Str(i) & ", " & Str(j) & ") = " & Str(imagedata(i, j))
                End If
            End If
        End If
    End If
End If
End Sub

Private Sub mnublue_Click()
Dim i As Integer
pop.numberPulses = 60
pop.pulseWidth = 1044
pop.pulsePeriod = 18270 ' opens filter wheel to blue position
lblresult.Caption = "Selecting Blue Filter"
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Select blue filter command failed!"
    Exit Sub
End If
qcsp.command = CC_PULSE_OUT
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 0   'wait for shutter to rotate to clear position
lblresult.Caption = "Blue filter selected"
End Sub

Private Sub mnuclear_Click()
Dim i As Integer
pop.numberPulses = 60
pop.pulseWidth = 1305
pop.pulsePeriod = 18270 ' opens filter wheel to clear position
lblresult.Caption = "Selecting Clear Filter"
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Select clear filter command failed!"
    Exit Sub
End If
qcsp.command = CC_PULSE_OUT
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 0   'wait for shutter to rotate to clear position
lblresult.Caption = "Clear filter selected"
End Sub

Private Sub mnuclosedriver_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End Sub

Private Sub mnucontrast_Click()
background = InputBox("Input new background: ", "Set New Background", Str(background))
range = InputBox("Input new range: ", "Set New Range", Str(range))
redrawimage
End Sub

Private Sub mnuestablishlink_Click()
Dim i As Integer
elp.port = 0
elp.baseAddress = &H378 'lpt1 on my machine - set for your configuration
i = ParDrvCommandVB(CC_ESTABLISH_LINK, elp, elr)
lblresult.Caption = "Error Code = " & Str(i) & ", camera type = " & Hex(elr.cameraType)
If i = 0 Then
establishlink = True
End If
End Sub

Private Sub mnuexit_Click()
Dim i1, i2 As Integer
i1 = ParDrvCommandVB(CC_CLOSE_DEVICE, 0, 0)
i2 = ParDrvCommandVB(CC_CLOSE_DRIVER, 0, 0)
lblresult.Caption = Str(i1) & "," & Str(i2)
End
End Sub

Private Sub mnucenterao_Click()
Dim i As Integer
aottp.xDeflection = 2048
aottp.yDeflection = 2048
i = ParDrvCommandVB(CC_AO_TIP_TILT, aottp, 0)
If i <> 0 Then
    MsgBox "Center AO command failed!"
    Exit Sub
End If
End Sub

Private Sub mnugetinfo_Click()
Dim i As Integer
i = ParDrvCommandVB(CC_GET_DRIVER_INFO, gdip, gdir)
lblresult.Caption = "Version = " & Hex(gdir.version) & "; Name: " & gdir.name
End Sub

Private Sub mnugreen_Click()
Dim i As Integer
pop.numberPulses = 60
pop.pulseWidth = 783
pop.pulsePeriod = 18270 ' opens filter wheel to green position
lblresult.Caption = "Selecting Green Filter"
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Select green filter command failed!"
    Exit Sub
End If
qcsp.command = CC_PULSE_OUT
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 0   'wait for shutter to rotate to clear position
lblresult.Caption = "Green filter selected"
End Sub

Private Sub mnuhidecross_Click()
frmST7driver.MousePointer = 0
showcrosshairdata = False
End Sub

Private Sub mnuopendriver_Click()
Dim i1, i2 As Integer
Dim odp As OpenDeviceParams

i1 = ParDrvCommandVB(CC_OPEN_DRIVER, 0, 0)
If i1 = 0 Then
    odp.port = 1 'lpt1
    i2 = ParDrvCommandVB(CC_OPEN_DEVICE, odp, 0)
End If
lblresult.Caption = Str(i1) & "," & Str(i2)
End Sub

Private Sub mnumoveao_Click()
Dim i, xdrive, ydrive As Integer
xdrive = InputBox("Input X drive level (0 to 4095): ", "X-Axis Drive Level ", 2048#)
ydrive = InputBox("Input Y drive level (0 to 4095): ", "Y-Axis Drive Level ", 2048#)
aottp.xDeflection = xdrive
aottp.yDeflection = ydrive
i = ParDrvCommandVB(CC_AO_TIP_TILT, aottp, 0)
If i <> 0 Then
    MsgBox "Move AO command failed!"
    Exit Sub
End If
End Sub

Private Sub mnured_Click()
Dim i As Integer
pop.numberPulses = 60
pop.pulseWidth = 522
pop.pulsePeriod = 18270 ' opens filter wheel to red position
lblresult.Caption = "Selecting Red Filter"
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Select red filter command failed!"
    Exit Sub
End If
qcsp.command = CC_PULSE_OUT
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 0   'wait for shutter to rotate to clear position
lblresult.Caption = "Red filter selected"
End Sub

Private Sub mnusave_Click()
Dim textline, endstring, wrap, header, controlz, desc As String
Dim alltext As String
Dim i, j, lineLength, filenum, pixeldata As Integer
Dim x, y, oldx, oldy As Single
Dim sum, numbytes As Long
Dim currenttime As Variant
wrap = Chr$(10) & Chr$(13)
controlz = Chr$(26)
If ST8camera = False Then
    alltext = "ST-7 Image" & wrap
Else
    alltext = "ST-8 Image" & wrap
End If
' no support for saving tracking CCD images is provided here
alltext = alltext & "File_version = 3" & wrap
alltext = alltext & "Data_version = 1" & wrap
alltext = alltext & "Exposure = 100" & wrap
alltext = alltext & "Focal_length = 50.000" & wrap
alltext = alltext & "Aperture = 40.000" & wrap
alltext = alltext & "Response_factor = 2000.000" & wrap
alltext = alltext & "Note = -" & wrap
alltext = alltext & "Background = " & Str(background) & wrap
alltext = alltext & "Range = " & Str(range) & wrap
alltext = alltext & "Height = " & Str(imageheight) & wrap
alltext = alltext & "Width = " & Str(imagewidth) & wrap
alltext = alltext & "Date = " & Str(Date) & wrap
alltext = alltext & "Time = " & Format(Time, "h:mm:ss") & wrap
alltext = alltext & "Exposure_state = 356" & wrap
alltext = alltext & "Temperature = 0.00" & wrap
alltext = alltext & "Number_exposures = 1" & wrap
alltext = alltext & "Each_exposure = 100" & wrap
alltext = alltext & "History = 0" & wrap
alltext = alltext & "Observer = -" & wrap
alltext = alltext & "X_pixel_size = 0.010" & wrap
alltext = alltext & "Y_pixel_size = 0.010" & wrap
alltext = alltext & "Pedestal = 0" & wrap
alltext = alltext & "E_gain = 1.25" & wrap
alltext = alltext & "End" & wrap
alltext = alltext & controlz
numbytes = Len(alltext)
i = 2048 - numbytes
For j = 1 To i
    alltext = alltext & " "
Next 'j
desc = InputBox("Input file name (without extension): ", "File name", "test")
filenum = FreeFile
lblresult.Caption = ""
Open "c:\vbprog\SBIG\" & desc & ".ST7" For Binary As filenum
For i = 1 To 2048
    Put #filenum, , CByte(Asc(Mid(alltext, i, 1)))
Next i
Put #filenum, , imagedata
Close filenum
lblresult.Caption = "Save completed"
End Sub

Private Sub mnusettemp_Click()
Dim tedrive As Byte
Dim i As Integer
strp.regulation = 2
tedrive = CByte(InputBox("Input Cooler Drive Level (0 to 255) ", "TE Cooler Drive Level", lastdrivelevel))
lastdrivelevel = tedrive
strp.ccdSetpoint = tedrive
i = ParDrvCommandVB(CC_SET_TEMPERATURE_REGULATION, strp, 0)
If i <> 0 Then
    MsgBox "Set drive level command failed!"
    Exit Sub
End If
End Sub

Private Sub mnusetupexposure_Click()
Dim framechoice As Integer
exposuretime = InputBox("Input exposure time: ", "Exposure Time", defaultexposure)
defaultexposure = exposuretime
exposure = CLng(exposuretime * 100)
 'following code is done to fix problem dll modules have with longs
sep.expLowByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expMidLowByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expMidHighByte = CByte(exposure Mod 256)
exposure = exposure \ 256
sep.expHighByte = CByte(exposure)
framechoice = MsgBox("Dark frame?", 36, "Select light or dark frame")
If framechoice = 6 Then
    darkframe = True
Else
    darkframe = False
End If
End Sub

Private Sub mnushowcross_Click()
frmST7driver.MousePointer = 2
showcrosshairdata = True
End Sub

Private Sub mnushowtemp_Click()
Dim i As Integer
i = ParDrvCommandVB(CC_QUERY_TEMPERATURE_STATUS, 0, qtsr)
lbltemp.Caption = "Ambient Temp in A/D units = " & Str(qtsr.ambientThermistor) & ", CCD temperature = " & Str(qtsr.ccdThermistor)
End Sub

Private Sub mnutakeexposure()
Dim i, j, k, min, max As Integer
Dim wrap As String
wrap = Chr$(10) & Chr$(13)
sep.ccd = 0 'selects imaging CCD
sep.abgState = 0
If darkframe = True Then
    sep.openShutter = 2
Else
    sep.openShutter = 1
End If
Tmrreadtemp.enabled = False
lblresult.Caption = "Starting Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_START_EXPOSURE, sep, 0)
If i <> 0 Then
    MsgBox "Start exposure command failed!"
    Exit Sub
End If
qcsp.command = CC_START_EXPOSURE
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 3   'waiting for imaging CCD to finish
eep.ccd = 0
lblresult.Caption = "Ending Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_END_EXPOSURE, eep, 0)
If i <> 0 Then
    MsgBox "End exposure command failed!"
    Exit Sub
End If
rlp.ccd = 0
If ST8camera = True Then
    rlp.readoutMode = 1 ' 2x2 binning on chip
Else
    rlp.readoutMode = 0 'full resolution
End If
rlp.pixelStart = 0
rlp.pixelLength = 765
lblresult.Caption = "Reading Out CCD"
lblresult.Refresh
lblprogresslabel.Caption = "Line being readout"
lblprogresslabel.Refresh
For j = 0 To 509
    If j Mod 20 = 0 Then
        lblprogress.Caption = Str(j)
        lblprogress.Refresh
    End If
    i = ParDrvCommandVB(CC_READOUT_LINE, rlp, linedata(0))
    If i <> 0 Then
        MsgBox "Readout exposure command failed for line " & Str(j)
        Exit Sub
    End If
    ' Visual Basic does not have word data types, so I truncate
    ' the data to avoid negative values
    For k = 0 To 764
    If linedata(k) > 0 Then
      imagedata(k, j) = linedata(k)
    Else
      imagedata(k, j) = 32767
    End If
    Next 'k
Next 'j
lblprogress.Caption = Str(j - 1)
lblprogress.Refresh
imageheight = 510
imagewidth = 765
min = 32767
max = 0
For j = 0 To imageheight - 1
    If imagedata(imagewidth \ 2, j) < min Then
    min = imagedata(imagewidth \ 2, j)
    End If
    If imagedata(imagewidth \ 2, j) > max Then
    max = imagedata(imagewidth \ 2, j)
    End If
Next j
background = min
range = max - min
lblresult.Caption = "Minimum value = " & Str(min) & wrap & "Maximum value = " & Str(max)
lblresult.Refresh
Tmrreadtemp.enabled = True
redrawimage
End Sub

Private Sub redrawimage()
Dim i, j, pixdata As Integer
Dim pixvalue As Byte
Dim rangedivider, pix As Single
rangedivider = range / 255#
lblprogresslabel.Caption = "Line being displayed"
lblprogresslabel.Refresh
For j = 0 To imageheight - 1
    If j Mod 20 = 0 Then
        lblprogress.Caption = Str(j)
        lblprogress.Refresh
    End If
    For i = 0 To imagewidth - 1
        pix = imagedata(i, j)
        If pix < 0 Then pix = 65536 - pix
        pix = (imagedata(i, j) - background) / rangedivider
        pixdata = CLng(pix)
        If pixdata > 255 Then
            pixdata = 255
        End If
        If pixdata < 0 Then
            pixdata = 0
        End If
        pixvalue = CByte(pixdata)
        frmST7driver.PSet (i + 40, j + 10), RGB(pixvalue, pixvalue, pixvalue)
    Next 'i
Next 'j
lblprogress.Caption = Str(j - 1)
lblprogress.Refresh
End Sub


Private Sub mnutakest7exposure_Click()
ST8camera = False
mnutakeexposure
End Sub

Private Sub mnutakest8exposure_Click()
ST8camera = True
mnutakeexposure
End Sub

Private Sub mnutrackccdexposure_Click()
Dim i, j, k, min, max As Integer
Dim wrap As String
wrap = Chr$(10) & Chr$(13)
sep.ccd = 1 'selects tracking CCD
sep.abgState = 0
If darkframe = True Then
    sep.openShutter = 2
Else
    sep.openShutter = 1
End If
Tmrreadtemp.enabled = False
lblresult.Caption = "Starting Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_START_EXPOSURE, sep, 0)
If i <> 0 Then
    MsgBox "Start exposure command failed!"
    Exit Sub
End If
qcsp.command = CC_START_EXPOSURE
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 12   'waiting for tracking CCD to finish
eep.ccd = 1 ' readout tracking CCD
lblresult.Caption = "Ending Exposure"
lblresult.Refresh
i = ParDrvCommandVB(CC_END_EXPOSURE, eep, 0)
If i <> 0 Then
    MsgBox "End exposure command failed!"
    Exit Sub
End If
rlp.ccd = 1
rlp.readoutMode = 0 'full resolution
rlp.pixelStart = 0
rlp.pixelLength = 192
lblresult.Caption = "Reading Out CCD"
lblresult.Refresh
lblprogresslabel.Caption = "Line being readout"
lblprogresslabel.Refresh
For j = 0 To 163
    If j Mod 20 = 0 Then
        lblprogress.Caption = Str(j)
        lblprogress.Refresh
    End If
    i = ParDrvCommandVB(CC_READOUT_LINE, rlp, linedata(0))
    If i <> 0 Then
        MsgBox "Readout exposure command failed for line " & Str(j)
        Exit Sub
    End If
    ' Visual Basic does not have word data types, so I truncate
    ' the data to avoid negative values
    For k = 0 To 191
    If linedata(k) > 0 Then
      imagedata(k, j) = linedata(k)
    Else
      imagedata(k, j) = 32767
    End If
    Next 'k
Next 'j
lblprogress.Caption = Str(j - 1)
lblprogress.Refresh
' find background value for display
imageheight = 164
imagewidth = 192
min = 32767
max = 0
For j = 0 To imageheight - 1
    If imagedata(imagewidth \ 2, j) < min Then
    min = imagedata(imagewidth \ 2, j)
    End If
    If imagedata(imagewidth \ 2, j) > max Then
    max = imagedata(imagewidth \ 2, j)
    End If
Next j
background = min
range = max - min
lblresult.Caption = "Minimum value = " & Str(min) & wrap & "Maximum value = " & Str(max)
lblresult.Refresh
Tmrreadtemp.enabled = True
redrawimage
End Sub

Private Sub mnuuser_Click()
Dim i As Integer
pop.numberPulses = 60
pop.pulseWidth = 1566
pop.pulsePeriod = 18270 ' opens filter wheel to blue position
lblresult.Caption = "Selecting User Filter"
i = ParDrvCommandVB(CC_PULSE_OUT, pop, 0)
If i <> 0 Then
    MsgBox "Select user filter command failed!"
    Exit Sub
End If
qcsp.command = CC_PULSE_OUT
Do
i = ParDrvCommandVB(CC_QUERY_COMMAND_STATUS, qcsp, qcsr)
Loop While qcsr.status <> 0   'wait for shutter to rotate to clear position
lblresult.Caption = "User filter selected"

End Sub

Private Sub Tmrreadtemp_Timer()
Dim i As Integer
If establishlink = True Then
i = ParDrvCommandVB(CC_QUERY_TEMPERATURE_STATUS, 0, qtsr)
lbltemp.Caption = "Ambient Temp in A/D units = " & Str(qtsr.ambientThermistor) & ", CCD temp in A/D units = " & Str(qtsr.ccdThermistor)
End If
End Sub


Private Sub mnuload_Click()
Dim alltext, textline, endstring, wrap, desc, header As String
Dim lineLength, filenum As Integer
Dim i, j As Integer
desc = InputBox("Input file name (without extension): ", "File name", "M51")
wrap = Chr$(13) & Chr$(10)
filenum = FreeFile
Open "c:\vbprog\SBIG\" & desc & ".ST7" For Input As filenum
Do
Line Input #filenum, textline
lineLength = Len(textline)
lineLength = lineLength - 1
If lineLength >= 3 Then
    alltext = alltext & Mid$(textline, 1, lineLength) & wrap
    endstring = Mid$(textline, 1, 3)
    If Mid$(textline, 1, 8) = "Height =" Then
        imageheight = CInt(Mid$(textline, 10, lineLength - 9))
    End If 'height
    If Mid$(textline, 1, 7) = "Width =" Then
        imagewidth = CInt(Mid$(textline, 9, lineLength - 8))
    End If 'width
    If Mid$(textline, 1, 12) = "Background =" Then
        background = CInt(Mid$(textline, 14, lineLength - 13))
    End If 'background
    If Mid$(textline, 1, 7) = "Range =" Then
        range = CInt(Mid$(textline, 9, lineLength - 8))
    End If 'range
End If
Loop While endstring <> "End"
Close filenum
header = " "
filenum = FreeFile
lblresult.Caption = ""
Open "c:\vbprog\SBIG\" & desc & ".ST7" For Binary As filenum
Get #filenum, 2048, header
Get #filenum, , imagedata
Close filenum
lblresult.Caption = "Width = " & Str(imagewidth) & "  Height = " & Str(imageheight)
redrawimage
End Sub

